// Generated by CoffeeScript 1.9.3
(function() {
  var chai, excelAsJson, expect;

  excelAsJson = require('../lib/excel-as-json');

  chai = require('chai');

  chai.should();

  expect = chai.expect;

  describe('assign', function() {
    it('should assign first level properties', function() {
      var subject;
      subject = {};
      excelAsJson.assign(subject, 'foo', 'clyde');
      return subject.foo.should.equal('clyde');
    });
    it('should assign second level properties', function() {
      var subject;
      subject = {};
      excelAsJson.assign(subject, 'foo.bar', 'wombat');
      return subject.foo.bar.should.equal('wombat');
    });
    it('should assign third level properties', function() {
      var subject;
      subject = {};
      excelAsJson.assign(subject, 'foo.bar.bazz', 'honey badger');
      return subject.foo.bar.bazz.should.equal('honey badger');
    });
    it('should overwrite existing values', function() {
      var subject;
      subject = {};
      excelAsJson.assign(subject, 'foo.bar.bazz', 'honey badger');
      subject.foo.bar.bazz.should.equal('honey badger');
      excelAsJson.assign(subject, 'foo.bar.bazz', "don't care");
      return subject.foo.bar.bazz.should.equal("don't care");
    });
    it('should assign any literal value', function() {
      var subject, test;
      subject = {};
      excelAsJson.assign(subject, 'foo.bar.bazz', 1);
      subject.foo.bar.bazz.should.equal(1);
      excelAsJson.assign(subject, 'foo.bar.bazz', ['a', 2, ['three']]);
      subject.foo.bar.bazz.toString().should.equal(['a', 2, ['three']].toString());
      test = {
        one: 1,
        'two': 'too'
      };
      excelAsJson.assign(subject, 'foo.bar.bazz', test);
      return JSON.stringify(subject.foo.bar.bazz).should.equal(JSON.stringify(test));
    });
    it('should assign properties to objects in a list', function() {
      var subject;
      subject = {};
      excelAsJson.assign(subject, 'foo.bar[0].what', 'that');
      return subject.foo.bar[0].what.should.equal('that');
    });
    it('should assign properties to objects in a list with first entry out of order', function() {
      var subject;
      subject = {};
      excelAsJson.assign(subject, 'foo.bar[1].what', 'that');
      excelAsJson.assign(subject, 'foo.bar[0].what', 'this');
      subject.foo.bar[0].what.should.equal('this');
      return subject.foo.bar[1].what.should.equal('that');
    });
    it('should assign properties to objects in a list with second entry out of order', function() {
      var subject;
      subject = {};
      excelAsJson.assign(subject, 'foo.bar[0].what', 'this');
      excelAsJson.assign(subject, 'foo.bar[2].what', 'that');
      excelAsJson.assign(subject, 'foo.bar[1].what', 'other');
      subject.foo.bar[0].what.should.equal('this');
      subject.foo.bar[2].what.should.equal('that');
      return subject.foo.bar[1].what.should.equal('other');
    });
    it('should split a semicolon delimited list for flat arrays', function() {
      var subject;
      subject = {};
      excelAsJson.assign(subject, 'foo.bar[]', 'peter;paul;mary');
      return subject.foo.bar.toString().should.equal(['peter', 'paul', 'mary'].toString());
    });
    return it('should not split a semicolon list with a terminal indexed array', function() {
      var subject;
      subject = {};
      excelAsJson.assign(subject, 'foo.bar[0]', 'peter;paul;mary');
      return subject.foo.bar.should.equal('peter;paul;mary');
    });
  });

}).call(this);
