// Generated by CoffeeScript 1.9.3
(function() {
  var COL_JSON, COL_XLSX, ROW_JSON, ROW_XLSX, chai, excelAsJson, expect, fs;

  excelAsJson = require('../lib/excel-as-json');

  fs = require('fs');

  chai = require('chai');

  chai.should();

  expect = chai.expect;

  ROW_XLSX = 'data/row-oriented.xlsx';

  ROW_JSON = 'build/row-oriented.json';

  COL_XLSX = 'data/col-oriented.xlsx';

  COL_JSON = 'build/col-oriented.json';

  describe('process', function() {
    it('should notify on file does not exist', function(done) {
      return excelAsJson.process('data/doesNotExist.xlsx', null, false, function(err, data) {
        err.should.be.a('string');
        expect(data).to.be.an('undefined');
        return done();
      });
    });
    it('should not blow up when a file does not exist and no callback is provided', function(done) {
      excelAsJson.process('data/doesNotExist.xlsx', function() {});
      return done();
    });
    it('should notify on read error', function(done) {
      return excelAsJson.process('data/row-oriented.csv', null, false, function(err, data) {
        err.should.be.a('string');
        expect(data).to.be.an('undefined');
        return done();
      });
    });
    it('should not blow up on read error when no callback is provided', function(done) {
      excelAsJson.process('data/row-oriented.csv', function() {});
      return done();
    });
    it('should process row oriented Excel files and return the parsed object', function(done) {
      try {
        fs.mkdirSync('build');
      } catch (_error) {

      }
      return excelAsJson.process(ROW_XLSX, ROW_JSON, false, function(err, data) {
        var result, resultStr;
        expect(err).to.be.an('undefined');
        result = JSON.parse(fs.readFileSync(ROW_JSON, 'utf8'));
        resultStr = '[{"firstName":"Jihad","lastName":"Saladin","address":{"street":"12 Beaver Court","city":"Snowmass","state":"CO","zip":"81615"}},{"firstName":"Marcus","lastName":"Rivapoli","address":{"street":"16 Vail Rd","city":"Vail","state":"CO","zip":"81657"}}]';
        JSON.stringify(result).should.equal(resultStr);
        JSON.stringify(data).should.equal(resultStr);
        return done();
      });
    });
    it('should process col oriented Excel files', function(done) {
      try {
        fs.mkdirSync('build');
      } catch (_error) {

      }
      return excelAsJson.process(COL_XLSX, COL_JSON, false, function(err, data) {
        var result, resultStr;
        expect(err).to.be.an('undefined');
        result = JSON.parse(fs.readFileSync(COL_JSON, 'utf8'));
        resultStr = '[{"firstName":"lastName","Jihad":"Saladin","Marcus":"Rivapoli"},{"firstName":"address.street","Jihad":"12 Beaver Court","Marcus":"16 Vail Rd"},{"firstName":"address.city","Jihad":"Snowmass","Marcus":"Vail"},{"firstName":"address.state","Jihad":"CO","Marcus":"CO"},{"firstName":"address.zip","Jihad":"81615","Marcus":"81657"},{"firstName":"phones[0].type","Jihad":"home","Marcus":"home"},{"firstName":"phones[0].number","Jihad":"123.456.7890","Marcus":"123.456.7891"},{"firstName":"phones[1].type","Jihad":"work","Marcus":"work"},{"firstName":"phones[1].number","Jihad":"098.765.4321","Marcus":"098.765.4322"},{"firstName":"aliases[]","Jihad":"stormagedden;bob","Marcus":"mac;markie"}]';
        JSON.stringify(result).should.equal(resultStr);
        JSON.stringify(data).should.equal(resultStr);
        return done();
      });
    });
    it('should return a parsed object without writing a file', function(done) {
      try {
        fs.unlinkSync(ROW_JSON);
      } catch (_error) {

      }
      return excelAsJson.process(ROW_XLSX, void 0, false, function(err, data) {
        var resultStr;
        expect(err).to.be.an('undefined');
        fs.existsSync(ROW_JSON).should.equal(false);
        resultStr = '[{"firstName":"Jihad","lastName":"Saladin","address":{"street":"12 Beaver Court","city":"Snowmass","state":"CO","zip":"81615"}},{"firstName":"Marcus","lastName":"Rivapoli","address":{"street":"16 Vail Rd","city":"Vail","state":"CO","zip":"81657"}}]';
        JSON.stringify(data).should.equal(resultStr);
        return done();
      });
    });
    it('should notify on write error', function(done) {
      try {
        fs.mkdirSync('build');
      } catch (_error) {

      }
      return excelAsJson.process(ROW_XLSX, 'build', false, function(err, data) {
        expect(err).to.be.an('string');
        return done();
      });
    });
    return it('should not blow up on write error when no callback is provided', function(done) {
      try {
        fs.mkdirSync('build');
      } catch (_error) {

      }
      excelAsJson.process(ROW_XLSX, 'build', false, function() {});
      return done();
    });
  });

}).call(this);
